var connect = require('mongodb-async').connect;
var testCollection = connect('127.0.0.1', 27017).db('test_mongodb_async').collection('test');

var doc = {x: (new Date).getTime() + ''};

var deferred = testCollection.insert(doc, {safe: true})
  .and(function onDocSaved(defer, result) {
    console.log('document saved');
    console.log(result);
    return true;
  })
  .and(function findDoc(outerDefer, result) {
    testCollection
      .findOne({x: doc.x})
      .and(function(innerDefer, docFound) {
        console.log('found: %s', docFound.x === result[0].x);
      })
      .fail(outerDefer.error);
  })
  .fail(function dumpFailure(err) {
    console.error(err.stack || err);
  });